variables: 
    IMAGE_NAME: tar1e/git-lab-python
    IMAGE_TAG: python-app-1.0

stages:
  - test
  - build
  - deploy

run_tests:
  stage: test
  image: python:3.9-slim-buster
  before_script:
    - apt-get update && apt-get install make
  script:
    - make test


build_image:
  stage: build
  image: docker:20.10.16
  services:
    - docker:20.10.16-dind
  variables:
    DOCKER_TLS_CERTDIR: "/certs"
  before_script: 
    - docker login -u $REGISTRY_USER -p $REGISTRY_PASS
  script:
    - docker build -t $IMAGE_NAME:$IMAGE_TAG .
    - docker push $IMAGE_NAME:$IMAGE_TAG 

deploy:
  stage: deploy
  before_script: 
    - chmod 400 $SSH_KEY
  script:
    - ssh -o StrictHostKeyCheking=no -i $SSH_KEY matvey@192.168.0.127 "
      docker login -u $REGISTRY_USER -p $REGISTRY_PASS &&
      docker ps -aq | xargs docker stop | xargs docker rm && 
      docker run -d -p 5000:5000 $IMAGE_NAME:$IMAGE_TAG"


